﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Core;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Hive.Contracts.BusinessObjects;
using HeuristicLab.Hive.Contracts;

namespace HeuristicLab.Hive.Experiment {
  public class JobItem : Item {
    [Storable]
    private JobDto jobDto;
    public JobDto JobDto {
      get { return jobDto; }
      set {
        if (jobDto != value) {
          jobDto = value;
          OnToStringChanged();
        }
      }
    }

    [Storable]
    private ResponseObject<SerializedJob> latestSnapshot;
    public ResponseObject<SerializedJob> LatestSnapshot {
      get { return latestSnapshot; }
      set {
        if (latestSnapshot != value) {
          latestSnapshot = value;
          latestSnapshotTime = DateTime.Now;
          OnLatestSnapshotChanged();
        }
      }
    }

    [Storable]
    private DateTime latestSnapshotTime;
    public DateTime LatestSnapshotTime {
      get { return latestSnapshotTime; }
    }

    public JobItem() {
    }

    public override string ToString() {
      if (jobDto != null) {
        return base.ToString() + " - " + jobDto.Id.ToString();
      } else {
        return base.ToString();
      }
    }

    public event EventHandler LatestSnapshotChanged;
    public void OnLatestSnapshotChanged() {
      EventHandler handler = LatestSnapshotChanged;
      if (handler != null) handler(this, EventArgs.Empty);
    }
  }
}
